.686
.model flat,stdcall
option casemap:none
assume fs:nothing
WIN32_LEAN_AND_MEAN equ <>
include windows.inc
include kernel32.inc
includelib kernel32.lib
include shell32.inc
includelib shell32.lib
include ole32.inc
includelib ole32.lib
include user32.inc
includelib user32.lib
include advapi32.inc
includelib advapi32.lib
include stdlib.inc
includelib stdlib.lib
include PEimage.asm
include ole2.inc

;DEBUG equ <>

.code
DbgPrintf proc c fmt:DWORD,args:VARARG
LOCAL buf[400h]:byte 
	pushfd
	pushad
	invoke wvsprintf,addr buf,fmt,addr args
	invoke OutputDebugString,addr buf
	popad
	popfd
	ret
DbgPrintf endp

dbg macro fmt:req,args:vararg
	ifdef DEBUG
	%echo fmt args
	ifb <args>
	invoke DbgPrintf,T(fmt),0
	else
	invoke DbgPrintf,T(fmt),args
	endif
	endif	
endm

.data?
dd? hInstance

.data
align 4
pIMalloc PIMalloc 0 
ServerLockCount dd 0
include interface.asm

.data
align 4
CLSIDStr db 'CLSID\'
CLSIDStr_PEiNFO db '{11BB9F57-4D13-4DA1-AB3C-3B9F1F8D584E}',0
PEiNFO_GUID GUID <011BB9F57h,04D13h,04DA1h,<0ABh,03Ch,03Bh,09Fh,01Fh,08Dh,058h,04Eh>>

.code

DllGetClassObject proc pclsid:DWORD,pguid:DWORD,ppv:DWORD
	invoke IsEqualGUID,pclsid,addr PEiNFO_GUID
	.if eax
		dbg 'SERVER GETCLASSOBJECT'; pclsid:%.8X, pguid:%.8X, ppv:%.8X',pclsid,pguid,ppv
		mov eax,offset pmycf
		mov edx,ppv
		mov [edx],eax
		mov ecx,[eax]
		dbg 'my call to IClassFactory.iIUnknown.QueryInterface'
		invoke [ecx].IClassFactory.iIUnknown.QueryInterface,eax,pguid,edx		
	.else
		mov eax,CLASS_E_CLASSNOTAVAILABLE	
	.endif
	ret
DllGetClassObject endp

DllCanUnloadNow proc
	dbg 'SERVER DLLCANUNLOADNOW ServerLockCount:%.8X',ServerLockCount
	.if ServerLockCount
		mov eax,S_FALSE
		ret
	.endif
	mov eax,S_OK
	ret
DllCanUnloadNow endp

DllRegisterServer proc
LOCAL szReg[200h]:byte
LOCAL szDllPath[MAX_PATH]:byte
	
	invoke StrCpy,addr szReg,addr CLSIDStr
	invoke RegKeyOpen,HKEY_CLASSES_ROOT,addr szReg,TRUE
	.if !eax
		invoke RegWriteStr,0,T('PEiNFO Context Menu Shell Extension')
		invoke RegKeyClose
	.endif
	invoke GetModuleFileName,hInstance,addr szDllPath,sizeof szDllPath
	invoke StrCat,addr szReg,T('\InprocServer32')
	invoke RegKeyOpen,HKEY_CLASSES_ROOT,addr szReg,TRUE
	.if !eax
		invoke RegWriteStr,0,addr szDllPath
		invoke RegWriteStr,T('ThreadingModel'),T('Apartment')
		invoke RegKeyClose
	.endif
	invoke RegKeyOpen,HKEY_CLASSES_ROOT,T('dllfile\shellex\ContextMenuHandlers\PEiNFO'),TRUE
	.if !eax
		invoke RegWriteStr,0,addr CLSIDStr_PEiNFO
		invoke RegKeyClose
	.endif
	invoke RegKeyOpen,HKEY_CLASSES_ROOT,T('exefile\shellex\ContextMenuHandlers\PEiNFO'),TRUE
	.if !eax
		invoke RegWriteStr,0,addr CLSIDStr_PEiNFO
		invoke RegKeyClose
	.endif
	;invoke SHChangeNotify,SHCNE_ASSOCCHANGED,SHCNF_IDLIST,0,0
	dbg 'SERVER REGISTERED'
	mov eax,S_OK
	ret
DllRegisterServer endp

DllUnregisterServer proc
LOCAL szReg[200h]:byte
	invoke RegDeleteKey,HKEY_CLASSES_ROOT,T('exefile\shellex\ContextMenuHandlers\PEiNFO')
	invoke RegDeleteKey,HKEY_CLASSES_ROOT,T('dllfile\shellex\ContextMenuHandlers\PEiNFO')
	invoke StrCpy,addr szReg,addr CLSIDStr
	invoke StrCat,addr szReg,T('\InprocServer32')
	invoke RegDeleteKey,HKEY_CLASSES_ROOT,addr szReg
	invoke RegDeleteKey,HKEY_CLASSES_ROOT,addr CLSIDStr
	;invoke SHChangeNotify,SHCNE_ASSOCCHANGED,SHCNF_IDLIST,0,0
	dbg 'SERVER UNREGISTERED'
	mov eax,S_OK
	ret
DllUnregisterServer endp

DllEntryPoint proc hinstDLL:DWORD, fdwReason:DWORD, lpvReserved:DWORD
	mov eax,fdwReason
	.if eax == DLL_PROCESS_ATTACH
		dbg 'SERVER DLL_PROCESS_ATTACH'
		m2mr hInstance,hinstDLL
		invoke CoGetMalloc,1,addr pIMalloc
		.if eax != S_OK
			mov eax,FALSE
			ret
		.endif
	.elseif eax == DLL_PROCESS_DETACH
		dbg 'SERVER DLL_PROCESS_DETACH'
	.endif
	mov eax,TRUE
	ret
DllEntryPoint Endp
End DllEntryPoint
