;Res\itview.dlg
IDD_DLG3						equ 400
IDC_LSV2						equ 401
IDC_LSV3						equ 402
IDC_CHK2						equ 403
.data?
align 16
pe PEIMAGE <>
dd? IT_Handle,hLv2,hLv3

.code

include getprocaddy.inc

.code
ListView_GetSelectedRow proc uses ebx hWnd
	xor ebx,ebx
	invoke SendMessage,hWnd,LVM_GETITEMCOUNT,ebx,ebx
	mov ebx,eax
	jmp @F
	.repeat
		invoke SendMessage,hWnd,LVM_GETITEMSTATE,ebx,LVIS_SELECTED
		.break .if eax
	@@:
		dec ebx
	.until sign?
	mov eax,ebx
	ret
ListView_GetSelectedRow endp

ListView_SetItem proc hWnd,ItemID,iSubItem,pszText
LOCAL LVItem:LV_ITEM
	mov LVItem.imask,LVIF_TEXT
	m2mr LVItem.pszText,pszText
	m2mr LVItem.iItem,ItemID
	m2mr LVItem.iSubItem,iSubItem
	invoke SendMessage,hWnd,LVM_SETITEM,0,ADDR LVItem
	ret
ListView_SetItem endp

ListView_InsertItem proc hWnd,ItemID,iSubItem,pszText
LOCAL LVItem:LV_ITEM
	mov LVItem.imask,LVIF_TEXT
	m2mr LVItem.pszText,pszText
	m2mr LVItem.iItem,ItemID
	m2mr LVItem.iSubItem,iSubItem
	invoke SendMessage,hWnd,LVM_INSERTITEM,0,ADDR LVItem
	ret
ListView_InsertItem endp


ListView_InsertColumn proc hWnd,nWidth,pszText
LOCAL LVColumn:LV_COLUMN
	mov LVColumn.imask,LVCF_FMT or LVCF_TEXT or LVCF_WIDTH
	mov LVColumn.fmt,LVCFMT_LEFT
	m2mr LVColumn.lx,nWidth
	m2mr LVColumn.pszText,pszText
	invoke SendMessage,hWnd,LVM_INSERTCOLUMN,0,ADDR LVColumn	
	ret
ListView_InsertColumn endp

.code
LV2AddItem proc uses ebx esi edi Col0:DWORD,Col1:DWORD,Col2:DWORD,Col3:DWORD,Col4:DWORD,Col5:DWORD
	xor ebx,ebx
	lea esi,Col0
	invoke SendMessage,hLv2,LVM_GETITEMCOUNT,ebx,ebx
	mov edi,eax
	invoke ListView_InsertItem,hLv2,edi,ebx,dword ptr [esi+ebx*4]
	mov edi,eax;ItemID,eax
	inc ebx
	.repeat
		invoke ListView_SetItem,hLv2,edi,ebx,dword ptr [esi+ebx*4]
		inc ebx
	.until ebx == 6
	mov eax,edi
	ret
LV2AddItem endp

LV3AddItem proc uses ebx esi edi Col0:DWORD,Col1:DWORD,Col2:DWORD,Col3:DWORD,Col4:DWORD
	xor ebx,ebx
	lea esi,Col0
	invoke SendMessage,hLv3,LVM_GETITEMCOUNT,ebx,ebx
	mov edi,eax
	invoke ListView_InsertItem,hLv3,edi,ebx,dword ptr [esi+ebx*4]
	mov edi,eax;ItemID,eax
	inc ebx
	.repeat
		invoke ListView_SetItem,hLv3,edi,ebx,dword ptr [esi+ebx*4]
		inc ebx
	.until ebx == 5
	mov eax,edi
	ret
LV3AddItem endp

InitITgui proc uses esi
	lea esi,ListView_InsertColumn
	fnListView_InsertColumn typedef proto :dword,:dword,:dword
	assume esi:ptr fnListView_InsertColumn
	invoke esi,hLv2,80,T('FirstThunk')
	invoke esi,hLv2,80,T('Name')
	invoke esi,hLv2,80,T('ForwarderChain')
	invoke esi,hLv2,80,T('TimeDateStamp')
	invoke esi,hLv2,80,T('OriginalFirstThunk')
	invoke esi,hLv2,80,T('DllName')	
	invoke SendMessage,hLv2,LVM_SETEXTENDEDLISTVIEWSTYLE,LVS_EX_GRIDLINES or LVS_EX_FULLROWSELECT,LVS_EX_GRIDLINES or LVS_EX_FULLROWSELECT
	invoke esi,hLv3,200,T('ApiName')
	invoke esi,hLv3,40,T('Hint')
	invoke esi,hLv3,80,T('ThunkValue')
	invoke esi,hLv3,80,T('ThunkOffset')
	invoke esi,hLv3,80,T('ThunkRVA')
	invoke SendMessage,hLv3,LVM_SETEXTENDEDLISTVIEWSTYLE,LVS_EX_GRIDLINES or LVS_EX_FULLROWSELECT,LVS_EX_GRIDLINES or LVS_EX_FULLROWSELECT
	assume esi:nothing 
	ret
InitITgui endp

UpdateITgui proc uses esi edi ebx
LOCAL tmpStr0[16]:byte,tmpStr1[16]:byte,tmpStr2[16]:byte
LOCAL tmpStr3[16]:byte,tmpStr4[16]:byte,tmpStr5[16]:byte
	invoke SendMessage,hLv2,LVM_DELETEALLITEMS,0,0	
	invoke PEImgDirEntryToData,addr pe,IMAGE_DIRECTORY_ENTRY_IMPORT
	mov esi,eax
	mov edi,edx
	add edi,esi
	assume esi:ptr IMAGE_IMPORT_DESCRIPTOR
	.while TRUE
		mov eax,[esi].FirstThunk
		.break .if !eax 
		.break .if esi>edi 
		invoke DwToHex,[esi].OriginalFirstThunk,addr tmpStr1
		invoke DwToHex,[esi].TimeDateStamp,addr tmpStr2
		invoke DwToHex,[esi].ForwarderChain,addr tmpStr3
		invoke DwToHex,[esi].Name1,addr tmpStr4
		invoke DwToHex,[esi].FirstThunk,addr tmpStr5
		invoke PEImgVa,addr pe,[esi].Name1
		mov ebx,eax
		invoke LV2AddItem,ebx,addr tmpStr1,addr tmpStr2,addr tmpStr3,addr tmpStr4,addr tmpStr5
		add esi,sizeof IMAGE_IMPORT_DESCRIPTOR
	.endw
	assume esi:nothing
	ret
UpdateITgui endp

UpdateIT2gui proc uses esi edi ebx pIT1index
LOCAL bOFT:BOOL,ft
LOCAL tmpStr0[16]:byte,tmpStr1[16]:byte,tmpStr2[16]:byte
LOCAL tmpStr3[16]:byte,tmpStr4[16]:byte,tmpStr5[16]:byte
	invoke IsDlgButtonChecked,IT_Handle,IDC_CHK2
	mov bOFT,eax 
	invoke SendMessage,hLv3,LVM_DELETEALLITEMS,0,0
	invoke PEImgDirEntryToData,addr pe,IMAGE_DIRECTORY_ENTRY_IMPORT
	mov esi,pIT1index
	imul esi,sizeof IMAGE_IMPORT_DESCRIPTOR
	add esi,eax
	add eax,edx
	.if esi > eax
		ret
	.endif
	mov ecx,[esi].IMAGE_IMPORT_DESCRIPTOR.TimeDateStamp
	mov edx,[esi].IMAGE_IMPORT_DESCRIPTOR.ForwarderChain
	.if ! (ecx == -1 &&  edx == -1)
		mov eax,[esi].IMAGE_IMPORT_DESCRIPTOR.FirstThunk
		.if bOFT
			.if [esi].IMAGE_IMPORT_DESCRIPTOR.OriginalFirstThunk
				mov eax,[esi].IMAGE_IMPORT_DESCRIPTOR.OriginalFirstThunk
			.endif
		.endif
		mov esi,eax
		test esi,esi
		jz @@Exit
		invoke PEImgVa,addr pe,eax
		mov edi,eax
		assume edi:ptr IMAGE_THUNK_DATA
		.while TRUE
			mov ebx,[edi].u1.AddressOfData
			.break .if !ebx
			invoke DwToHex,esi,addr tmpStr0
			invoke PEImgRvaToOffset,addr pe,esi
			lea edx,tmpStr1
			invoke DwToHex,eax,edx
			invoke DwToHex,ebx,addr tmpStr2
			.if ebx & IMAGE_ORDINAL_FLAG32
				mov word ptr tmpStr3[0],'-'
				and ebx,not IMAGE_ORDINAL_FLAG32
				mov dword ptr tmpStr4[0],'drO'
				invoke DwToStr,ebx,addr tmpStr4[3]
				lea edx,tmpStr4
		    .else
				invoke PEImgVa,addr pe,ebx
				mov ebx,eax
				movzx ecx,[ebx].IMAGE_IMPORT_BY_NAME.Hint
				invoke DwToHex,ecx,addr tmpStr3
				mov eax,dword ptr tmpStr3[4]
				mov dword ptr tmpStr3[0],eax
				mov byte ptr tmpStr3[4],0
				lea edx,[ebx].IMAGE_IMPORT_BY_NAME.Name1
		    .endif
			invoke LV3AddItem,addr tmpStr0,addr tmpStr1,addr tmpStr2,addr tmpStr3,edx
			add edi,sizeof IMAGE_THUNK_DATA
			add esi,sizeof IMAGE_THUNK_DATA
		.endw
		assume edi:nothing
	.else
		mov esi,[esi].IMAGE_IMPORT_DESCRIPTOR.OriginalFirstThunk
		test esi,esi
		jz @@Exit
		invoke PEImgVa,addr pe,esi
		mov edi,eax
		assume edi:ptr IMAGE_THUNK_DATA
		.while TRUE
			mov ebx,[edi].u1.AddressOfData
			.break .if !ebx
			invoke DwToHex,esi,addr tmpStr0
			invoke PEImgRvaToOffset,addr pe,esi
			lea edx,tmpStr1
			invoke DwToHex,eax,edx
			invoke DwToHex,ebx,addr tmpStr2
			.if ebx & IMAGE_ORDINAL_FLAG32
		    	mov word ptr tmpStr3[0],'-'
		    	and ebx,not IMAGE_ORDINAL_FLAG32
		    	mov dword ptr tmpStr4[0],'drO'
		    	invoke DwToStr,ebx,addr tmpStr4[3]
		    	lea edx,tmpStr4
		    .else
			    invoke PEImgVa,addr pe,ebx
			    mov ebx,eax
			    movzx ecx,[ebx].IMAGE_IMPORT_BY_NAME.Hint
				invoke DwToHex,ecx,addr tmpStr3
				mov eax,dword ptr tmpStr3[4]
				mov dword ptr tmpStr3[0],eax
				mov byte ptr tmpStr3[4],0
				lea edx,[ebx].IMAGE_IMPORT_BY_NAME.Name1
		    .endif
			invoke LV3AddItem,addr tmpStr0,addr tmpStr1,addr tmpStr2,addr tmpStr3,edx
			add edi,sizeof IMAGE_THUNK_DATA
			add esi,sizeof IMAGE_THUNK_DATA
		.endw
		assume edi:nothing
	.endif
@@Exit:	
	ret
UpdateIT2gui endp

LVCopyRowToClipBrd proc uses ebx esi edi hWnd,indx
LOCAL lvi:LV_ITEM
LOCAL tbuf[20h]:byte
LOCAL tbuf2[20h*6]:byte 
	mov lvi.imask,LVIF_TEXT
	mov lvi.cchTextMax,20h
	lea eax,tbuf
	xor ebx,ebx
	mov lvi.iItem,ecx
	mov lvi.pszText,eax
	mov tbuf2[0],bl
	.repeat
		mov lvi.iSubItem,ebx
		invoke SendMessage,hWnd,LVM_GETITEM,0,addr lvi
		invoke StrCat,addr tbuf2,addr tbuf
		invoke StrCat,addr tbuf2,T(' ')
		inc ebx
	.until ebx == 6
	invoke OpenClipboard,IT_Handle
	invoke lstrlen,addr tbuf2
	lea ebx,[eax+1]
	invoke GlobalAlloc,GPTR+GMEM_DDESHARE,ebx
	mov edi,eax
	invoke EmptyClipboard
	mov ecx,ebx
	push edi
	lea esi,tbuf2
	rep movsb
	pop edi
	invoke SetClipboardData,CF_TEXT,edi
	invoke CloseClipboard
	;;invoke MessageBox,IT_Handle,addr tbuf2,0,MB_OK
	ret
LVCopyRowToClipBrd endp

IT_OnNotify proc uses ebx idCtrl:dword, pnmh:dword
	mov ebx,pnmh
	assume ebx:ptr NM_LISTVIEW
	.if idCtrl == IDC_LSV2
		.if [ebx].hdr.code == NM_CLICK; || [ebx].hdr.code == LVN_ITEMCHANGED
			mov ecx,[ebx].iItem
			.if ecx != -1
				invoke UpdateIT2gui,ecx
			.endif
		.elseif [ebx].hdr.code == NM_DBLCLK
			mov ecx,[ebx].iItem
			.if ecx != -1
				invoke LVCopyRowToClipBrd,hLv2,ecx
			.endif
		.endif
	.elseif idCtrl == IDC_LSV3
		.if [ebx].hdr.code == NM_DBLCLK
			mov ecx,[ebx].iItem
			.if ecx != -1
				invoke LVCopyRowToClipBrd,hLv3,ecx
			.endif
		.endif
	.endif
	assume ebx:nothing
	ret
IT_OnNotify endp

IT_DlgProc proc hWnd:HWND,uMsg:UINT,wParam:DWORD,lParam:LPARAM
	mov eax,uMsg
	.if eax==WM_INITDIALOG
		m2mr IT_Handle,hWnd
		invoke GetDlgItem,hWnd,IDC_LSV2
		mov hLv2,eax
		invoke GetDlgItem,hWnd,IDC_LSV3
		mov hLv3,eax
		invoke PEImgDirEntryToData,addr pe,IMAGE_DIRECTORY_ENTRY_IMPORT
		.if eax && edx 
			invoke InitITgui
			invoke UpdateITgui
		.else
			invoke EndDialog,hWnd,-1
		.endif
	.elseif eax==WM_NOTIFY
		invoke IT_OnNotify,wParam,lParam
	.elseif eax == WM_COMMAND
		.if wParam == IDC_CHK2 
			invoke ListView_GetSelectedRow,hLv2
			.if eax != -1
				invoke UpdateIT2gui,eax
			.endif
		.endif	
	.elseif eax==WM_CLOSE
		invoke EndDialog,hWnd,0
	.else
	xor eax,eax
	ret
	.endif
	mov eax,TRUE
	ret
IT_DlgProc endp


ViewImpTable proc hwnd:dword,pszPeFile:dword
	invoke PEImgCreate,addr pe,pszPeFile,TRUE
	.if eax
		invoke DialogBoxParam,hInstance,IDD_DLG3,hwnd,addr IT_DlgProc,0
		.if eax == -1
			invoke MessageBox,hwnd,T('File Has no Import Directory'),0,MB_ICONWARNING
		.endif
		invoke PEImgFree,addr pe
	.else
		invoke MessageBox,hwnd,pszPeFile,0,MB_ICONERROR		
	.endif
	ret
ViewImpTable endp


