.const
	RegKeyClose				PROTO
	RegKeyOpen				PROTO	:DWORD,:DWORD,:DWORD
	RegReadDw				PROTO	:DWORD
	RegReadStr				PROTO	:DWORD,:DWORD,:DWORD
	RegWriteDw				PROTO	:DWORD,:DWORD
	RegWriteStr				PROTO	:DWORD,:DWORD
	
.data?
	OpenedKey dd ? 
	bCreated dd ?

.code
ALIGN DWORD
RegKeyOpen proc hKey:dword, pSubKey:dword, bCreate:dword
	m2m bCreated,bCreate
	.if bCreate
		invoke RegCreateKeyEx,hKey,pSubKey,0,0,REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,0,addr OpenedKey,0
	.else
		invoke RegOpenKeyEx,hKey,pSubKey,0,KEY_READ,addr OpenedKey
	.endif
	ret
RegKeyOpen endp

ALIGN DWORD
RegKeyClose proc
	invoke RegCloseKey,OpenedKey
	ret
RegKeyClose endp

ALIGN DWORD
RegReadDw proc pValueName:dword
local Data:dword, DataSize:dword
	mov DataSize,Sizeof dword
	.if OpenedKey!=0
		invoke RegQueryValueEx,OpenedKey,pValueName,0,0,addr Data,addr DataSize
		mov eax,Data	
	.endif
	ret
RegReadDw endp

ALIGN DWORD
RegWriteDw proc pValueName:dword, dwValue:dword
	.if OpenedKey!=0 && bCreated
		invoke RegSetValueEx,OpenedKey,pValueName,0,REG_DWORD,addr dwValue,Sizeof dword
	.endif
	ret
RegWriteDw endp

ALIGN DWORD
RegReadStr proc pValueName:dword, pBuffer:dword, BufSize:dword
	.if OpenedKey!=0
		invoke RegQueryValueEx,OpenedKey,pValueName,0,0,pBuffer,addr BufSize
		mov eax,BufSize
		dec eax
	.endif
	ret
RegReadStr endp

ALIGN DWORD
RegWriteStr proc pValueName:dword, pStr:dword 
	.if OpenedKey!=0 && bCreated
		xor eax,eax
		.if pStr != eax
			invoke StrLen,pStr
		.endif
		invoke RegSetValueEx,OpenedKey,pValueName,0,REG_SZ,pStr,eax
	.endif
	ret
RegWriteStr endp



